indexing
   description: "Button with command list to specify behaviour"

class BUTTON

create set_command

--------------------------
feature

set_command (new_command : COMMAND) is
  -- Register a new COMMAND
  require
    new_command_not_void: new_command /= Void
  do
    associated_command := new_command
  ensure
    associated_command = new_command
  end
      
associated_command : COMMAND
  -- Command that must be executed when the BUTTON is pressed

activate is
  -- Execute the associated_command 
  do
    associated_command.execute
  end

invariant
  associated_command_not_void: associated_command /= Void

end
